﻿using System;
using System.IO;
using System.Net;
using System.Text;

namespace Plane.Util
{
    public class AsynDataUtils
    {
        public delegate void DataResultCallBack(string data,bool haveerror);
        DataResultCallBack _callback;
        bool haveerror;
        string errorstr;
        public bool AsynGetData(string tagUrl, DataResultCallBack callback, out string verrorstr)
        {
            haveerror = false;
            errorstr = "";
            try
            {
                _callback = callback;
                AsyncGetWithWebRequest(tagUrl, new AsyncCallback(ReadCallback));
            }
            catch (Exception ex)
            {
                errorstr += ex.Message;
                haveerror = true;
                Console.WriteLine(ex.Message);
 
            }
            verrorstr = errorstr;
            return !haveerror;
        }

        private void ReadCallback(IAsyncResult asynchronousResult)
        {
            try
            {
               string DefaultUserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
                var request = (HttpWebRequest)asynchronousResult.AsyncState;
                request.Timeout = 5000;
                request.Method = "GET";
                request.UserAgent = DefaultUserAgent;

                var response = (HttpWebResponse)request.EndGetResponse(asynchronousResult);
                using (var streamReader = new StreamReader(response.GetResponseStream(), System.Text.Encoding.Default ))
                {
                    var resultString = streamReader.ReadToEnd();
                    Console.WriteLine(resultString);
                    if (_callback != null)
                    {
                        _callback(resultString,false);
                    }
                }
            }
            catch (Exception ex)
            {
                if (_callback != null)
                {
                    _callback(ex.Message, true);
                }
                Console.WriteLine(ex.Message);
             
            }

        }
        private void AsyncGetWithWebRequest(string url, AsyncCallback callback)
        {
            var request = (HttpWebRequest)System.Net.WebRequest.Create(new Uri(url));
            request.BeginGetResponse(callback, request);
        }
    }
}
